# Development notes

## Standard build 

    jlpm build && python3 -m pip install -e .

## Custom Install with NPM

This is useful if you want to build a 'linked' version of @motionsignaltechnologies/cate-web

    # Node setup
    export NVM_DIR="$HOME/.nvm"
    [ -s "$NVM_DIR/nvm.sh" ] && \. "$NVM_DIR/nvm.sh"  # This loads nvm
    [ -s "$NVM_DIR/bash_completion" ] && \. "$NVM_DIR/bash_completion"  # This loads nvm bash_completion
    rm yarn.lock

    npm link @motionsignaltechnologies/cate-web
    
    npm run build:lib
    npm run build:lib:prod
    npm run build:labextension
    
    python3 -m pip install -v .

## Publishing

Do this from MSF-Lab no twine builder

1. Install builder and twine
 
    pip install build twine hatch

2. Set version number

    hatch version <new-version>

3. Clean up

    jlpm clean:all
    git clean -dfX
    

4. Build 

    python3 -m build
    
6. Deploy Python
   
    twine upload dist/*
    
7. Deploy NPM
 
    npm login
    npm publish --access public
